"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LanguageDetector = void 0;

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.function.name");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = require("../../common/utils");

var _lookup = require("../lookup");

/* eslint-disable @typescript-eslint/indent */
// import {
//   LanguageDetectorAllOptions,
//   LanguageDetectorCaches,
//   LanguageDetectorOptions,
//   LanguageDetectorOrder,
//   LanguageDetectorServices,
// } from '../../../typings';
// import sessionLookup from './languageLookups/session';
function getDefaults() {
  return {
    order: ['path', 'querystring', 'cookie', 'header'],
    lookupQuerystring: 'lng',
    lookupCookie: 'i18next',
    lookupSession: 'lng',
    lookupFromPathIndex: 0,
    // cache user language
    caches: false // ['cookie']
    //cookieExpirationDate: new Date(),
    //cookieDomain: 'myDomain'

  };
}

var LanguageDetector =
/*#__PURE__*/
function () {
  function LanguageDetector(services, options, allOptions) {
    (0, _classCallCheck2["default"])(this, LanguageDetector);
    (0, _defineProperty2["default"])(this, "type", void 0);
    (0, _defineProperty2["default"])(this, "detectors", void 0);
    (0, _defineProperty2["default"])(this, "services", void 0);
    (0, _defineProperty2["default"])(this, "options", void 0);
    (0, _defineProperty2["default"])(this, "allOptions", void 0);
    this.detectors = {};
    this.init(services, options, allOptions);
  }

  (0, _createClass2["default"])(LanguageDetector, [{
    key: "init",
    value: function init(services) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var allOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      this.services = services;
      this.options = (0, _utils.defaults)(options || getDefaults());
      this.allOptions = allOptions;
      this.addDetector(_lookup.cookie);
      this.addDetector(_lookup.querystring);
      this.addDetector(_lookup.path);
      this.addDetector(_lookup.header);
    }
  }, {
    key: "addDetector",
    value: function addDetector(detector) {
      this.detectors[detector.name] = detector;
    }
  }, {
    key: "detect",
    value: function detect(req, res, detectionOrder) {
      var _this = this;

      if (!detectionOrder) detectionOrder = this.options.order; // let found;

      return detectionOrder.forEach(function (detectorName) {
        // if (found || !this.detectors[detectorName]) return;
        if (!_this.detectors[detectorName]) return;
        var detector = _this.detectors[detectorName];
        var detections = detector.lookup(req, res, _this.options);
        if (!detections) return;
        if (!_lodash["default"].isArray(detections)) detections = [detections];
        var selectedLanguages = detections.forEach(function (lng) {
          if (!_lodash["default"].isString(lng)) return;

          var cleanedLng = _this.services.languageUtils.formatLanguageCode(lng);

          if (_this.services.languageUtils.isWhitelisted(cleanedLng)) {
            req.headers['i18nextLookupName'] = detectorName;
            return cleanedLng;
          }
        });

        if (_lodash["default"].isArray(selectedLanguages) && selectedLanguages.length > 1) {
          return selectedLanguages[0];
        }
      });
    } // cacheUserLanguage(
    //   req: http.IncomingMessage,
    //   res: http.ServerResponse,
    //   lng: string,
    //   caches?: LanguageDetectorCaches
    // ) {
    //   if (!caches) {
    //     caches = this.options.caches;
    //   }
    //   if (caches) {
    //     caches.forEach(cacheName => {
    //       if (this.detectors[cacheName] && this.detectors[cacheName].cacheUserLanguage)
    //         this.detectors[cacheName].cacheUserLanguage(req, res, lng, this.options);
    //     });
    //   }
    // }

  }]);
  return LanguageDetector;
}();

exports.LanguageDetector = LanguageDetector;