"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sendResponse = sendResponse;
exports.redirect = redirect;
exports.redirectWithoutCache = void 0;

/**
 * Composes and sends an HTTP response
 */
function sendResponse(res, statusCode, body, headers) {
  res.writeHead(statusCode, headers);
  res.end(body);
}
/**
 * Sends a redirect response
 */


function redirect(res, location) {
  var permanent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  sendResponse(res, permanent ? 301 : 302, null, {
    Location: location
  });
}

var redirectWithoutCache = function redirectWithoutCache(res, redirectLocation) {
  redirect(res, redirectLocation, true);
};

exports.redirectWithoutCache = redirectWithoutCache;