/**
 * Composes and sends an HTTP response
 */
export function sendResponse(res, statusCode, body, headers) {
  res.writeHead(statusCode, headers);
  res.end(body);
}
/**
 * Sends a redirect response
 */

export function redirect(res, location, permanent = false) {
  sendResponse(res, permanent ? 301 : 302, null, {
    Location: location
  });
}
export const redirectWithoutCache = (res, redirectLocation) => {
  redirect(res, redirectLocation, true);
};